declare type CapsuleFunc = () => Promise<any>;
declare class TaskQueue {
    queue: CapsuleFunc[];
    errorStack: Error[];
    _abortFlag: boolean;
    _doneFlag: boolean;
    _handleFlag: boolean;
    total: number;
    succeed: number;
    failed: number;
    executed: number;
    toleration: number;
    __resolve?: Function;
    __reject?: Function;
    constructor(toleration?: number);
    /**
     * Add a task to the queue
     * @param {TaskCapsule|function} task Task to be executed
     */
    add: (task: CapsuleFunc) => void;
    __prepareToBegin: () => boolean;
    __execAmountChange: (num: number) => void;
    __consumeValid(): boolean;
    __finish: () => void;
    abort(): void;
}
declare type ParallelQueueArguments = {
    limit?: number;
    toleration?: number;
    span?: number;
};
export declare class ParallelQueue extends TaskQueue {
    limitation: number;
    timespan: number;
    constructor({ limit, span, toleration }: ParallelQueueArguments);
    __start: () => void;
    consume(): Promise<unknown>;
}
declare type SerialQueueArguments = {
    abortAfterFail?: boolean;
    toleration?: number;
};
export declare class SerialQueue extends TaskQueue {
    abortAfterFail: boolean;
    constructor({ abortAfterFail, toleration }: SerialQueueArguments);
    __start(): void;
    consume(): Promise<unknown>;
    abort(): void;
}
export {};
//# sourceMappingURL=index.d.ts.map